'ͻ
' PB-IPX                                                   Version 2.0 
'͹
' Adapted for PowerBasic 3.x                           4 February 1998 
' By Marc van den Dikkenberg                           The Netherlands 
'                                                                      
' Status: Freeware      ---------> internet:   ipx@excelsior.xs4all.nl 
'                                                                      
' The PowerBasic Archives -------> http://www.xs4all.nl/~excel/pb.html 
'͹
' Based on David Rice's IPX Library for QuickBasic 4.0  (24 July 1992) 
'ͼ

DECLARE SUB RelenquishControl ()
DECLARE SUB SocketListen ()
DECLARE SUB CloseSocket (Socket%)
DECLARE SUB SendPacket (CompleteCode%, InUseFlag%)
DECLARE SUB OpenSocket (Socket%, Status%, SocketNumberReturned%)
DECLARE SUB IPXMarker (Interval%)
DECLARE SUB GetMyAddress (MyNetwork$, MyNode$, MyNetworkHex$, MyNodeHex$)
DECLARE SUB IPXSchedule (DelayTicks%)
DECLARE SUB IPXDisconnect (DNet$, DNode$, DSock$)
DECLARE SUB IPXCancelR (CompleteCode%)
DECLARE SUB IPXCancelS (CompleteCode%)
DECLARE FUNCTION SplitWordLo% (TheWord%)
DECLARE FUNCTION SplitWordHi% (TheWord%)
DECLARE FUNCTION IPXInstalled% ()
DECLARE FUNCTION TurnToHex$ (Variable$)
DECLARE FUNCTION HexToBinary$ (Variable$)

TYPE ECBStructure
   LinkAddressOff AS INTEGER
   LinkAddressSeg AS INTEGER
   ESRAddressOff  AS INTEGER
   ESRAddressSeg  AS INTEGER
   InUse       AS STRING * 1
   CompCode    AS STRING * 1
   SockNum     AS INTEGER
   IPXWorkSpc  AS SINGLE
   DrvWorkSpc  AS STRING * 12
   ImmAdd      AS STRING * 6
   FragCount   AS INTEGER
   FragAddOfs  AS INTEGER
   FragAddSeg  AS INTEGER
   FragSize    AS INTEGER
END TYPE

'              This is the IPX Packet Structure.
'
TYPE FullNetAddress
   NetWork     AS STRING * 4
   Node        AS STRING * 6
   Socket      AS STRING * 2
END TYPE
'
TYPE IPXHeader
   Checksum    AS INTEGER
   Length      AS INTEGER
   Control     AS STRING * 1
   PacketType  AS STRING * 1
   DestNet     AS STRING * 4
   DestNode    AS STRING * 6
   DestSocket  AS STRING * 2
   SourNet     AS STRING * 4
   SourNode    AS STRING * 6
   SourSock    AS STRING * 2
   '
   '           Send / Receive one character at a time.
   '
   Datagram    AS STRING * 1
END TYPE
'
DIM IPXS AS SHARED IPXHeader, IPXR AS SHARED IPXHeader
DIM ECBS AS SHARED ECBStructure, ECBR AS SHARED ECBStructure

DIM Disconnect AS SHARED FullNetAddress
DIM CompleteCode AS SHARED INTEGER, InUseFlag AS SHARED INTEGER, Socket(2) AS SHARED INTEGER
