'ͻ
' PB-IPX                                                   Version 2.0 
'͹
' Adapted for PowerBasic 3.x                           4 February 1998 
' By Marc van den Dikkenberg                           The Netherlands 
'                                                                      
' Status: Freeware      ---------> internet:   ipx@excelsior.xs4all.nl 
'                                                                      
' The PowerBasic Archives -------> http://www.xs4all.nl/~excel/pb.html 
'͹
' Based on David Rice's IPX Library for QuickBasic 4.0  (24 July 1992) 
'ͼ

SUB CloseSocket (Socket%)
   IF BIT(pbvhost,8)=1 then
      socket??=socket%
      ! MOV BX,1
      ! MOV AX,0
      ! MOV DX,Socket??
      ! INT &H7A
   ELSE
      Reg 2, 1
      Reg 1, 0
      Reg 4, Socket
      CALL INTERRUPT &H7A
   END IF
END SUB

FUNCTION HexToBinary$ (Variable$)
   IF Variable$ = "" THEN
      HexToBinary$ = ""
   ELSE
      A = LEN(Variable$) MOD 2
      IF A = 1 THEN
         HexToBinary$ = ""
      ELSE
         Temp$ = ""
         FOR A = 1 TO LEN(Variable$) STEP 2
            Temp! = VAL("&H" + MID$(Variable$, A, 2))
            Temp$ = Temp$ + CHR$(Temp!)
         NEXT
         HexToBinary$ = Temp$
      END IF
   END IF
END FUNCTION

SUB IPXCancelR (CompleteCode%)
   IF BIT(PBVHOST,8)=1 THEN
      plop???=VARSEG(ECBR)
      plip???=VARPTR(ECBR)
      ! MOV BX,6
      ! MOV ES,plop???
      ! MOV SI,plip???
      ! INT &H7A
      ! MOV plup%,AX
      CompleteCode = splitwordLo%(plup%)
   ELSE
      Reg 2, 6
      Reg 9, VARSEG(ECBR)
      Reg 5, VARPTR(ECBR)
      CALL INTERRUPT &H7A
      CompleteCode = SplitWordLo%(Reg(1))
   END IF
   '                    FC = was canceled
END SUB

SUB IPXCancelS (CompleteCode%)
   IF BIT(PBVHOST,8)=1 THEN
      plop???=VARSEG(ECBS)
      plip???=VARPTR(ECBS)
      ! MOV BX,6
      ! MOV ES,plop???
      ! MOV SI,plip???
      ! INT &H7A
      ! MOV plup%,AX
      CompleteCode=SplitWordLo%(plup%)
   ELSE
      Reg 2, 6
      Reg 9, VARSEG(ECBS)
      Reg 5, VARPTR(ECBS)
      CALL INTERRUPT &H7A
      CompleteCode = SplitWordLo%(Reg(1))
   END IF
   '                    FC = was canceled
END SUB

SUB IPXDisconnect (DNet$, DNode$, DSock$)
   Disconnect.NetWork = DNet$
   Disconnect.Node = DNode$
   Disconnect.Socket = DSock$
   IF BIT(PBVHOST,8)=1 THEN
      plop???=VARSEG(Disconnect)
      plip???=VARPTR(Disconnect)
      ! MOV BX,&HB
      ! MOV ES,plop???
      ! MOV SI,plip???
      ! INT &H7A
   ELSE
      Reg 2, &HB
      Reg 9, VARSEG(Disconnect)
      Reg 5, VARPTR(Disconnect)
      CALL INTERRUPT &H7A
   END IF
END SUB

FUNCTION IPXInstalled%
   IF BIT(PBVHOST,8)=1 THEN
      ! MOV AX,&H7A00
      ! INT &H2F
      ! MOV plop%,AX
      AL=SplitWordLo(plop%)
   ELSE
      Reg 1, &H7A00
      CALL INTERRUPT &H2F
      AL = SplitWordLo(Reg(1))
   END IF
   IF AL = &HFF THEN IPXInstalled = 1 ELSE IPXInstalled = 0
END FUNCTION

SUB OpenSocket (Socket%, Status%, SocketNumberReturned%)
   IF BIT(PBVHOST,8)=1 THEN
      socket??=socket%
      ! MOV BX,0
      ! MOV AX,0
      ! MOV DX,Socket??
      ! INT &H7A
      ! MOV plop%,AX
      ! MOV plip%,DX
      Status=SplitWordLo(plop%)
      SocketNumberReturned=plip%
   ELSE
      Reg 2, 0
      Reg 1, 0
      Reg 4, Socket
      CALL INTERRUPT &H7A
      Status = SplitWordLo(Reg(1))
      SocketNumberReturned = Reg(4)
   END IF
   '         00 successful
   '         FF open already
   '         FE socket table is full
END SUB

SUB RelenquishControl
   IF BIT(PBVHOST,8)=1 THEN
      ! MOV AX,0
      ! MOV BX,&HA
      ! INT &H7A
   ELSE
      Reg 1, 0
      Reg 2, &HA
      CALL INTERRUPT &H7A
   END IF
END SUB

SUB SendPacket (CompleteCode%, InUseFlag%)
   IF BIT(PBVHOST,8)=1 THEN
      plop???=varseg(ECBS)
      plip??=varptr(ECBS)
      ! MOV BX,3
      ! MOV ES,plop???
      ! MOV SI,plip??
      ! INT &H7A
   ELSE
      Reg 2, 3
      Reg 9, VARSEG(ECBS)
      Reg 5, VARPTR(ECBS)
      CALL INTERRUPT &H7A
   END IF
   CompleteCode = ASC(ECBS.CompCode)
   InUseFlag = ASC(ECBS.InUse)
   '        Error codes:
   '              00    sent
   '              FC    canceled
   '              FD    malformed packet
   '              FE    no listener (undelivered)
   '              FF    hardware failure
END SUB

SUB SocketListen
   IF BIT(PBVHOST,8)=1 THEN
      plop???=VARSEG(ECBR)
      plip???=VARPTR(ECBR)
      ! MOV BX,4
      ! MOV ES,plop???
      ! MOV SI,plip???
      ! INT &H7A
   ELSE
      Reg 2, 4
      Reg 9, VARSEG(ECBR)
      Reg 5, VARPTR(ECBR)
      CALL INTERRUPT &H7A
   END IF
   CompleteCode = ASC(ECBR.CompCode)
   InUseFlag = ASC(ECBR.InUse)
   '        Completion codes:
   '              00    received
   '              FC    canceled
   '              FD    packet overflow
   '              FF    socket was closed
   '              FE    Listening
END SUB

FUNCTION SplitWordHi% (TheWord%)
   SplitWordHi = (TheWord% AND &HFF00) / 256
END FUNCTION

FUNCTION SplitWordLo% (TheWord%)
   SplitWordLo = (TheWord% AND &HFF)
END FUNCTION

FUNCTION TurnToHex$ (Variable$)
   Temp$ = ""
   FOR Byte = 1 TO LEN(Variable$)
      Value! = ASC(MID$(Variable$, Byte, 1))
      IF Value! < 15 THEN
         Temp$ = Temp$ + "0" + HEX$(Value!)
      ELSE
         Temp$ = Temp$ + HEX$(Value!)
      END IF
   NEXT
   TurnToHex$ = Temp$
END FUNCTION

